
#include "exec.h"
#include "interpret.h"

#define VAR(i) (current_object->variables[\
		current_object->prog->inherit[inh_offset + (i).var_inherit].\
		variable_index_offset	+ (i).var_index])

typedef struct var_info
{
    char *name;
    short var_index;
    short var_inherit;
} var;


typedef struct func_info
{
    char *name;
    void (*address)();
} func;

struct interface
{
    char *program;
    var  **vars;
    func **funcs;
};
